brain_two/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path("admin/", admin.site.urls),
    path("todos/", include("todos.urls")),
]

todos/urls.py
from django.urls import path

from todos.views import (
    TodoListView,
    TodoDetailView,
    TodoCreateView,
    TodoDeleteView,
    TodoUpdateView,
)

urlpatterns = [
    path("", TodoListView.as_view(), name="todo_list_list"),
    path("<int:pk>/", TodoDetailView.as_view(), name="todo_list_detail"),
    path("create/", TodoCreateView.as_view(), name="todo_list_create"),
    path("<int:pk>/delete", TodoDeleteView.as_view(), name="todo_list_delete"),
    path("<int:pk>/edit", TodoUpdateView.as_view(), name="todo_list_update"),
]

todos/models.py
from django.db import models

# Create your models here.
class TodoList(models.Model):
    name = models.CharField(max_length=100)
    created_on = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name


class TodoItem(models.Model):
    task = models.CharField(max_length=100)
    due_date = models.DateTimeField(null=True, blank=True)
    is_completed = models.BooleanField(default=False)
    list = models.ForeignKey(
        "TodoList", related_name="items", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.task

todos/views.py
from multiprocessing import context
from django.urls import reverse_lazy
from django.views.generic import ListView, DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from todos.models import TodoItem, TodoList

# Create your views here.
class TodoListView(ListView):
    model = TodoList
    template_name = "todos/list.html"

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     print(context)
    #     return context


class TodoDetailView(DetailView):
    model = TodoList
    template_name = "todos/detail.html"
    # model context is read in detail as todolist

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     print(context)
    #     return context


class TodoCreateView(CreateView):
    model = TodoList
    template_name = "todos/new.html"
    fields = ["name"]
    success_url = reverse_lazy("todo_list_detail")


class TodoUpdateView(UpdateView):
    model = TodoList
    template_name = "todos/edit.html"
    fields = ["name"]
    success_url = reverse_lazy("todo_list_detail")


class TodoDeleteView(DeleteView):
    model = TodoList
    template_name = "todos/delete.html"
    success_url = reverse_lazy("todo_list_list")


class TodoItemCreateView(CreateView):
    model = TodoItem
    fields = ["task"]
    template_name = "todos/new_item.html"
    success_url = reverse_lazy("todo_list_detail")

todos/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    {% block content %}
    {% endblock content %}
</body>
</html>

todos/templates/todos/delete.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div>
            <h1>Are you sure?</h1>
            <form method="POST">
                {% csrf_token %}
                <button>Delete</button>
            </form>
        </div>
    </main>
{% endblock content %}

todos/templates/todos/detail.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div>
            <h1>{{ todolist.name }}</h1>
            <p><a href="{% url 'todo_list_update' todolist.pk %}">Edit</a></p>
            <p><a href="{% url 'todo_list_delete' todolist.pk %}">Delete</a></p>
            <h2>Tasks</h2>
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Due Date</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for todoitem in todolist.items.all %}
                        {% comment %} classname.primarykeyvariable.all {% endcomment %}
                            <tr>
                                <td>{{ todoitem.task }}</td>
                                <td>{{ todoitem.due_date }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
        </div>
    </main>
{% endblock content %}

todos/templates/todos/edit.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Update list</h1>
            <form method="POST">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Update</button>
            </form>
        </div>
    </main>
{% endblock content %}

todos/templates/todos/list.html
{% extends 'base.html' %}
{% block content %}   
    <main>
        <div>
            <h1>My Lists</h1>
            <p><a href="{% url 'todo_list_create' %}">Create a new list</a></p>
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Number of items</th>
                    </tr>
                </thead>
                <tbody>
                    {% for todolist in todolist_list %} 
                    {% comment %} todolist_list comes from context of listview {% endcomment %}
                        <tr>
                            <td><a href="{% url 'todo_list_detail' todolist.pk %}">{{ todolist.name }}</a></td>
                            {% comment %} todo_list_detail from url, todolist.pk from model todolist {% endcomment %}
                            <td>{{ todolist.items.all|length }}</td>
                        </tr>
                    {% endfor %}
      
                </tbody>
            </table>
        </div>
    </main>
{% endblock content %} 

todos/templates/todos/new.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new list</h1>
            <form method="POST">
                <input type="text" name="name">
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}